﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Collections.ObjectModel;
using System.ComponentModel;


namespace testhier
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public class MyParent : INotifyPropertyChanged
        {
            public event PropertyChangedEventHandler PropertyChanged;
            private void NotifyPropertyChanged(String info)
            {
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs(info));
                }
            }

            public ObservableCollection<MyChild> MyChildren { get; set; }
            public string Name { get; set; }

            private bool _IsParentSelected;
            public bool IsParentSelected
            {
                get
                {
                    System.Diagnostics.Debug.WriteLine(_IsParentSelected + Name, "get__IsParentSelected");
                    return _IsParentSelected;
                }
                set
                {
                    System.Diagnostics.Debug.WriteLine(_IsParentSelected + Name, "set__IsParentSelected");
                    if (_IsParentSelected != value)
                    {
                        _IsParentSelected = value;
                        NotifyPropertyChanged("IsParentSelected");
                    }
                }
            }
        }
        public class MyChild
        {
            public string Name { get; set; }
        }

        public Window1()
        {
            InitializeComponent();

            MyParent parent = new MyParent() { Name = "Parent1" }; 
            parent.MyChildren = new ObservableCollection<MyChild>();
            parent.MyChildren.Add( new MyChild() { Name = "Child1" });
            parent.MyChildren.Add( new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });

            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child1" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });
            parent.MyChildren.Add(new MyChild() { Name = "Child2" });

            ObservableCollection<MyParent> MyParents = new ObservableCollection<MyParent>();
            MyParents.Add(parent);
            MyParents.Add( new MyParent() { Name = "Parent2", MyChildren = new ObservableCollection<MyChild>() });
            MyParents.Add(new MyParent() { Name = "Parent3", MyChildren = new ObservableCollection<MyChild>() });

            XamDataGrid1.DataSource = MyParents;


        }
    }
}
